BECKHOFF Fieldbus Components

Documentation for

CU1128

EtherCAT hub

Version 1.0
Date: 2012-11-06

EtherCAT® is registered trademark and patented technology, licensed by Beckhoff Automation GmbH, Germany.


Notes on the documentation

This description is only intended for the use of trained specialists in control and automation engineering who are familiar with the applicable national standards.
It is essential that the following notes and explanations are followed when installing and commissioning these components.

The responsible staff must ensure that the application or use of the products described satisfy all the requirements for safety, including all the relevant laws, regulations, guidelines and standards.

Disclaimer

The documentation has been prepared with care. The products described are, however, constantly under development.
For that reason the documentation is not in every case checked for consistency with performance data, standards or other characteristics.
In the event that it contains technical or editorial errors, we retain the right to make alterations at any time and without warning.
No claims for the modification of products that have already been supplied may be made on the basis of the data, diagrams and descriptions in this documentation.

Trademarks

Beckhoff®, TwinCAT®, EtherCAT®, Safety over EtherCAT®, TwinSAFE® and XFC® are registered trademarks of and licensed by Beckhoff Automation GmbH.
Other designations used in this publication may be trademarks whose use by third parties for their own purposes could violate the rights of the owners.

Patent Pending

The EtherCAT Technology is covered, including but not limited to the following patent applications and patents:
EP1590927, EP1789857, DE102004044764, DE102007017835
with corresponding applications or registrations in various other countries.

The TwinCAT Technology is covered, including but not limited to the following patent applications and patents:
EP0851348, US6167425 with corresponding applications or registrations in various other countries.

Copyright

© Beckhoff Automation GmbH.
The reproduction, distribution and utilization of this document as well as the communication of its contents to others without express authorization are prohibited.
Offenders will be held liable for the payment of damages. All rights reserved in the event of the grant of a patent, utility model or design.


Safety Instructions

Safety Rules

Consider the following safety instructions and descriptions!
Product specific safety instructions are to be found on the following pages or in the areas mounting, wiring, commissioning etc.

Disclaimer

All the components are supplied in particular hardware and software configurations appropriate for the application. Modifications to hardware or software configurations other than those described in the documentation are not permitted, and nullify the liability of Beckhoff Automation GmbH.

Personnel Qualification

This description is only intended for the use of trained specialists in control, automation and drive engineering who are familiar with the applicable national standards.

Description of symbols

The following symbols with a adjoining safety advise or notice are used in this documentation. You have to read the safety advices carefully and adhere them strictly!

DANGER 		Acute risk of injury!
If you do not adhere the safety advise adjoining this symbol, there is immediate danger to life and health of individuals!

WARNING 		Risk of injury!
If you do not adhere the safety advise adjoining this symbol, there is danger to life and health of individuals!

CAUTION 		Hazard to individuals!
If you do not adhere the safety advise adjoining this symbol, there is obvious hazard to individuals!

Attention 		Hazard to environment and devices
If you do not adhere the notice adjoining this symbol, there is obvious hazard to environment and devices.

Note 		Note or pointer
This symbol indicates information that contributes to better understanding.
UL Pointer
This symbol indicates important information about the UL-compliant.


CU1128 - Documentation Issue Status

BECKHOFF CU1128: Foreword

Documentation Issue Status

Version | Comment
1.0 | - Addenda - 1st public issue
0.1 | - Preliminary version


Version identification

BECKHOFF: Foreword

Version identification of EtherCAT devices

Designation

A Beckhoff EtherCAT device has a 14-digit designation, made up of

  • family key
  • type
  • version
  • revision
Example | Family | Type | Version | Revision
EL3314-0000-0016 | EL terminal (12 mm, non-pluggable connection level) | 3314 (4-channel thermocouple terminal) | 0000 (basic type) | 0016
CU2008-0000-0000 | CU device | 2008 (8-port fast ethernet switch) | 0000 (basic type) | 0000
ES3602-0010-0017 | ES terminal (12 mm, pluggable connection level) | 3602 (2-channel voltage measurement) | 0010 (high-precision version) | 0017

Notes

  • The order identifier is made up of
    - family key
    - type
    - version
  • The revision indicates the technical progress and is managed by Beckhoff.
    In principle, a device with a higher revision can replace a device with a lower revision, unless specified otherwise.
    Each revision usually has an associated XML description (ESI, EtherCAT Slave information), which is available for download from the Beckhoff webpage.
  • Type, version and revision are read as decimal numbers.

Serial number

Beckhoff EtherCAT devices usually have an 8-digit serial number, which is printed on the device or attached to it on a sticker. This serial number indicates the construction condition on delivery.

Syntax of the serial number

Structure of the serial number: KK YY FF HH

KK - week of production (CW, calendar week)
YY - year of production
FF - firmware version
HH - hardware version

Example with ser. no.: 12 06 3A 02:

12 - week of production 12
06 - year of production 2006
3A - firmware version 3A
02 - hardware version 02

Examples of serial number data

Fig. 1: EL6688 EL Terminal

Fig. 2: CU2016 Switch

Fig. 3: EK1100 EtherCAT coupler


CU1128 - Introduction

Line, tree or star: EtherCAT supports almost any topology. If a star topology requires several branches at a particular point, the 8-way CU1128 EtherCAT hub can be used instead of several EK1122 devices. Port 1 is the input port for the network. Further EK1100 or EtherCAT Box modules can be connected at ports 2 to 8. The EtherCAT junctions are connected via RJ 45 sockets with direct display of link and activity status.

In conjunction with TwinCAT or other suitable EtherCAT masters the CU1128 also supports coupling and uncoupling of EtherCAT strands during operation (Hot Connect). The device cannot be used as a standard Ethernet switch.


CU1128 - Technical Data

BECKHOFF CU1128: Product Overview

Technical data

Technical data | CU1128
Task within EtherCAT system | Coupling of EtherCAT junctions
Data transfer medium | Ethernet/EtherCAT cable (min. CAT 5), shielded
Bus interface | 8 x RJ 45
Distance between stations | max. 100 m (100BASE-TX)
Protocol | EtherCAT
Distributed Clocks | yes
Delay | approx. 1 µs per port
Data transfer rates | 100 MBaud
Power supply | via 3-pin connector (+, -, PE)
Supply voltage | 24 VDC (18 VDC to 30 VDC)
Current consumption | typ. 185 mA
Weight | ca. 430 g
Dimensions without connector (B x H x T) | ca. 122 mm x 100 mm x 38 mm
Mounting | on 35 mm mounting rail (mounting rail according to EN 50022)
Operating temperature | 0°C ... + 55°C
Storage temperature | -25°C ... + 85°C
Relative humidity | 95 %, no condensation
Vibration/shock resistance | conforms to EN 60068-2-6 / EN 60068-2-27
EMV-Festigkeit / Aussendung | conforms to EN 61000-6-2 / EN 61000-6-4
Schutzart | IP 20
Einbaulage | variable
Zulassung | CE UL


CU1128 - Basic function principles

BECKHOFF CU1128: Product overview

Basic Function Principles

The CU1128 is an infrastructure device without controllable input/output data (I/O). It can be used:

  • as a junction point for conducted Fast Ethernet, in order to connect EtherCAT terminal stations, drives or any other EtherCAT slaves to drop lines
  • as distributed clock reference clock (see notes)

It has no I/O and no CoE directory and is not parameterizable. The core functions of the link control and distributed clocks synchronization are mapped by the ESCs.

Structure

In order to provide 8 EtherCAT connections, the CU1128 has 3 internal communication ICs (ESCs), which are connected in series internally. For this reason the CU1128 appears as 3 individual slaves in the EtherCAT configurator, although they are located in one housing. The interrelationship between the internal ESC ports (A, B, C, D) and the descriptions of the connection sockets (1..8) is as follows:

Fig. 1: diagram CU1128

Accordingly, 3 devices are displayed in the TwinCAT System Manager:

Fig. 2: 3 slaves in the TwinCAT System Manager

Please note:

  • port 1 is always the input for the EtherCAT traffic in the CU1128
  • the other ports (2..7) should be used as outputs
  • it is not permitted to delete subdevices once the CU1128 has been configured

For differentiation see also EEPROM Update.

1Topological configuration

With the CU1128, special attention should be paid to the sequence of the EtherCAT slaves. Since the CU1128 has 7 junction ports, drop lines connected to ports must and can be clearly identified in practice. If incorrect information is provided in the configuration (TwinCAT System Manager file *.tsm), the system cannot start.

For each EtherCAT device the System Manager indicates at which PreviousPort it is connected, i.e. the name of the connected port (B to D) of the previous slave. This also applies for the internal connections between the ESCs in the CU1128:

Fig. 3: previous port of the second ESC in the CU1128

As an example, Fig. 3 indicates that the second ESC in CU1128 “Box 1”, referred to as “Term 2”, is connected to ESC 1 Port C, cf. Fig. 1. This setting cannot be changed, since it is defined by the CU1128 device.
In general, however, it can be changed, if a pluggable coupler, EtherCAT box or similar is present in the configuration, see Fig. 4. Then,

  • drag & drop with the mouse can then be used in the System Manager to set up the general position in the I/O system
  • the in the fine adjustment the previous port can be selected, if several options are available.

Fig. 4: setting the PreviousPort for a EK1100

In Fig. 4 the coupler “Term 4” is configured to follow ESC2 “Term 2”. In the PreviousPort dialog of the EK1100 both free ESC2 ports (B and D, see Fig. 1) are therefore available for selection. B is selected in this example. The System Manager detects whether ports can technically and actually be connected by means of the port property, i.e. Ethernet or E-bus in the ESI/XML device descriptions. The internal connections in the CU1128 are E-bus connections, the 8 ports on the other hand are Ethernet, see Fig. 1.

See also notes for configuration setup.


EtherCAT Branches - Basic Function Principles

BECKHOFF EtherCAT: Basic Function Principles

Functionality basics EtherCAT junctions

Beckhoff provides several EtherCAT devices, which are suitable as branches in the EtherCAT strand (e.g. EK1122, EK1521, EP1122 or CU1128).
Due to similar functionality and technical characteristics, the following examples only refer to EK1122.

EtherCAT handling in the slaves

With EtherCAT as fieldbus protocol a wide range of bus topologies can be used: line, star and tree topology, with redundancy support even ring topology. The simplest topology is the line topology, in which each EtherCAT slave hands data over to the only available next slave, see Fig. 1.

Fig. 1: EtherCAT line topology

If EK1100 EtherCAT couplers are used, for example, branches and therefore a kind of tree topology is possible, see Fig. 2.

Fig. 2: Line topology with extensions

The basic principle is that internally the Ethernet frame(s) with the EtherCAT protocol data continue to be transported in a logical ring:

  • the EtherCAT master sends the frame on the two outgoing lines of the Ethernet cable
  • this frame passes each slave once,
  • is reversed by the last slave in the logical sequence
  • and is returned to the master through each EtherCAT slave via two return lines of the Ethernet cable without further processing.

At short cycle times in the order of 50 µs at 20,000 Ethernet frames are in transit in the EtherCAT system every second, plus acyclical organizational frames. The master awaits the return of the sent frames, which return the device input data to the master, for example. Telegram transfer between slaves is link-based: An EtherCAT slave will only forward a frame if a 'link' signal to the next device is present. Normally it can be assumed that the downstream device correctly processes each EtherCAT telegram and returns or process it at the end.

The crucial factor for forwarding EtherCAT telegrams is that a link signal is reported only from one slave to the next if both slaves are actually ready for real-time participation in data processing. Specifically, this means that an EtherCAT slave should not open the respective Ethernet port until it is ready to receive and forward an Ethernet frame immediately.

A switch or router is usually used for standard Ethernet traffic forwarding. Any collisions or frame losses are compensated through frame repetition in the higher level protocol layers (e.g. TCP). This mode is generally not used for EtherCAT due to the short cycle times and the real-time requirement. Some Ethernet devices such as special switches, for example, report a link to the remote terminal even if they will only be ready for data processing in a few milliseconds. This behavior is particularly noticeable in media converters from 100Base-TX (copper) to 100Base-Fx (optical fibre cable), which may report a link to the preceding EtherCAT slave even if the optical fiber connection is interrupted, depending on the setting on the copper side.

Fast link detection is therefore a central component of each ESC (EtherCAT slave controller, hardware processing unit for the EtherCAT protocol). According to the EtherCAT specification an ESC can have and control 1 to 4 ports. Via an open port it can handle outgoing and incoming Ethernet traffic. The direction of data flow in a fully configured ESC is shown in Fig. 3. The data in the EtherCAT datagrams are only processed in the EtherCAT processing unit between port 0 (A) and 3 (D).

Fig. 3: Direction of data flow in the ESC

Ideally link detection and therefore port handling in the ESC should be fast enough that lost frame events are avoided even at 100 µs cycle time. Nevertheless, at least one lost frame can never be ruled out if a connection is disconnected while an Ethernet frame is in transit on this line and in the bus segment downstream of the separation point.

Implementation: EL terminal

A standard EtherCAT slave with 2 ports (such as Beckhoff EL terminals) has 2 ports:

  • one for incoming frames (port 0 [A])
  • and one for outgoing frames (e.g. port 3 [D]).

The other two ports are internally closed in the ESC. An EtherCAT telegram enters the processing unit via port 0 (A) /top and is forwarded to the next slave via port 3 (D) /left, if a link to this port exists - see green arrows. This is the case if a further EL terminal is connected to the right.

If no link exists, the frame is forwarded to port 1(B) via the purple route. This and port 2 (C) have no link and therefore return the frame to port 0 (A), where the frame leaves via the same Ethernet port through which it arrived at the slave. This is the case if the terminal acts as end terminal.

An EtherCAT device with a single port is therefore only of limited use, since it can only be used as end device.

Implementation: EK1100 EtherCAT coupler

In the EK1100 EtherCAT coupler 3 of the 4 available ports are used, so that a connection to the right to terminals and via an RJ45 socket to further couplers is possible, see Fig. 2. In the EK1100 the processing unit is not used for process data exchange.

Implementation: EK1122 EtherCAT branch

In the EK1122 all 4 ESC ports can be connected - two via the internal E-bus and two via the RJ45 sockets with Ethernet configuration. The TwinCAT System Manager shows the link status of the ports 0, 1, 2 and 3 on the online display. They are identified as port A, B, C and D, see Fig. 7.

Implementation: EK1521/EK1521-0010/EK1561 EtherCAT branch

In the couplers above 3 ESC ports can be connected (like in the EK1100), two via the internal E-bus and one via the SC/versatile link socket and optical fibre/POF cable.

Implementation: CU1128 EtherCAT branch

3 ESC ports are integrated in the CU1128, in total 8 ports can be occupied by the user. The 3 ESC are connected to each other via the E-Bus

Example configuration with EK1122

The following section describes the link characteristics under TwinCAT and its representation in the System Manager.

Fig. 4: Example configuration

The TwinCAT online topology shows the wiring scheme, see Fig. 5. The EK1122 is selected, so that further information is shown. The green bars above the slaves indicate the correct RUN state in all slaves.

Fig. 5: Online topology

An error is now generated by disconnecting the connection between the upper RJ45 socket (X1) and the EL3102 device. Within a few µs the ESC in the EK1122 detects the lost link and automatically closes the affected port. The next incoming EtherCAT frame is then immediately forwarded to port D (3) and the EL4732. The link is therefore missing and the System Manager indicates this in the online display, see Fig. 6.

Fig. 6: Example configuration with interrupted cable

The System Manager messages can be interpreted as follows:

  • Address 1002 - EK1122: "OP LNK:MIS D": The slave is in OP state, although link is missing at port D (3) that should be present according to the configuration
  • Address 1003 - EK1100: "INIT NO_COMM": Since communication with this slave is interrupted its state is shown as INIT
  • Address 1004 - EL3104: ditto

Note 		Logger output
The logger output can be displayed in the lower part of the System Manager (Display--> Show Logger Output).

This may be helpful for diagnostic purposes (for link interruptions and other situations).

In the topology display any slaves affected by interruption are shown with a red border, see Fig. 7.

Fig. 7: Topology display for interrupted line

Please note the acyclic frame display in Fig. 4 and 6, see Fig. 8.

Fig. 8: Comparison of the frame displays in the System Manager from Fig. 4 and 6

The image on the left shows a small number (2) of acyclic frames sent by the master during the respective second - all slaves are operating properly. The image on the right shows a significant increase (currently 77 acyclic frames/sec): The EtherCAT master has quickly detected that not all slaves are properly taking part in the data exchange. Once the master has located the fault, it continuously tries to restore the connection.

Reconnection

Once the connection has been restored, the EK1122 reports to the master that a link is present again at port D (3). The EtherCAT master will then make its process data available again for this section. One the preparations are complete, it will instruct the EK1122 to re-open port D (3)for regular data exchange. Cyclic and acyclic data traffic with the other EtherCAT slaves continues normally.

Note 		External access to EtherCAT diagnostics
The system offers a wide range of options for accessing status and diagnostic information and EtherCAT master functions from the PLC. Almost all information displayed by the System Manager online can also be retrieved via ADS (see figures on this page). System Manager functions can also be triggered via PLC or ADS.

Please refer to the relevant sections in the Beckhoff Information System and the notes on EtherCAT diagnostics.


CU20xx, CU22xx - Mounting and Removal

BECKHOFF CU20xx, CU22xx: Mounting and Commissioning

Mounting and Removal

The CU20xx switches are fastened to the assembly surface with the aid of a 35 mm top-hat rail (a mounting rail according to EN 50022).

Assembly
  • Fit the mounting rail to the planned assembly location.
  • Suspend the switch on the mounting rail with the spring on the lower side of its latching flange.
  • Press the switch upwards (1).
  • Press the upper side of the switch (2) against the assembly surface until it latches in the mounting rail.
  • Attach the cable.

Removal
  • Remove all the cables.
  • Press the switch upwards (3).
  • Pull the other side of the switch (4) away from the assembly surface.


CU1128 - Cabling

BECKHOFF CU1128: Mounting and wiring

Cabling

Power Supply

Pinning of the supply connector

EtherCAT

Pinning of the RJ45 socket


CU1128 - Dimensions

BECKHOFF CU1128: Mounting and wiring

Dimensions

Note 		Required space in control cabinet
  • The RJ45 Plugs extends the depth depending to their design and the used Ethernet cable.
  • You have to add app. 10 mm extra space above the c-rail for snapping the switch onto the c-rail.
CU1128


CU1128 - Quick start

BECKHOFF CU1128: Commissioning

Quick start

No special measures are required for commissioning the CU1128.

Install the CU1128 as described in section Installation and wiring.
Notes on creation the configuration you will find in the chapter Configuration in the TwinCAT System Manager


CU1128 - Distributed clocks reference clock

BECKHOFF CU1128: Commissioning

Distributed clocks reference clock

The distributed clock unit in the CU1128 is activated by default. The CU1128 can therefore be used as distributed clocks (DC) reference clock. The EtherCAT reference clock should be located near the start of the system hierarchy, in particular before flexible components (HotConnect). It is therefore advisable to use couplers or junction components such as the CU1128 as DC reference clock.

By default the TwinCAT System Manager uses the first DC-capable terminal/coupler as reference clock, see Fig. 1.

Fig. 1: example topology with EL7201 as reference clock

If the junction with the EL7201 was uncoupled, e.g. due to topology changes during machine runtime or a fault, the EtherCAT system would lose its reference clock. Central components should therefore deal with this function.

Under Advanced settings for first CU1128 (ESC1), tick the UseAsPotentialReferenceClock checkbox.

Fig. 2: activating the CU1128 DC function

Once activated, TwinCAT selects the CU1128 as reference clock.

Fig. 3: CU1128 as reference clock

This function can be activated in components, refer here to the notices in the EK1100 documentation.


General Notes - EtherCAT Slave Application

Table of contents
• Diagnosis in real time: WorkingCounter, EtherCAT State and Status
• CoE - Parameter Directory
• Commissioning aid in the TwinCAT System Manager
 • EtherCAT State: automatic default behavior of the TwinCAT System Manager and manual operation
• Note regarding E-Bus current

This summary briefly deals with a number of aspects of EtherCAT Slave operation under TwinCAT. More detailed information on this may be found in the corresponding sections of, for instance,http://www.beckhoff.com/english/download/ethercat.htm#SystemDescription"> EtherCAT System Documentation.

Diagnosis in real time: WorkingCounter, EtherCAT State and Status

Generally speaking an EtherCAT Slave provides a variety of diagnostic information that can be used by the controlling task.

This diagnostic information relates to differing levels of communication. It therefore has a variety of sources, and is also updated at various times.

Any application that relies on I/O data from a fieldbus being correct and up to date must make diagnostic access to the corresponding underlying layers. EtherCAT and the TwinCAT System Manager offer comprehensive diagnostic elements of this kind. Those diagnostic elements that are helpful to the controlling task for diagnosis that is accurate for the current cycle when in operation (not during commissioning) are discussed below.

Fig. 1: Selection of the diagnostic information of an EtherCAT Slave

In general, an EtherCAT Slave offers

  • communication diagnosis typical for a slave (diagnosis of successful participation in the exchange of process data, and correct operating mode)
    This diagnosis is the same for all slaves.

    as well as
  • function diagnosis typical for a channel (device-dependent)
    See the corresponding device documentation

The colours in Fig. 1 also correspond to the variable colours in the System Manager, see Fig. 2.

Colour | Meaning
yellow | Input variables from the Slave to the EtherCAT Master, updated in every cycle
red | Output variables from the Slave to the EtherCAT Master, updated in every cycle
green | Information variables for the EtherCAT Master that are updated acyclically. This means that it is possible that in any particular cycle they do not represent the latest possible status. It is therefore useful to read such variables through ADS.

Fig. 2 shows an example of an implementation of basic EtherCAT Slave Diagnosis. A Beckhoff EL3102 (2-channel analogue input terminal) is used here, as it offers both the communication diagnosis typical of a slave and the functional diagnosis that is specific to a channel. Structures are created as input variables in the PLC, each corresponding to the process image.

Fig. 2: basic EtherCAT Slave Diagnosis in the PLC

The following aspects are covered here:

Code Function Implementation Application/evaluation
A The EtherCAT Master's diagnostic information

updated acyclically (yellow) or provided acyclically (green).

 At least the DevState is to be evaluated for the most recent cycle in the PLC.

The EtherCAT Master's diagnostic information offers many more possibilities than are treated in the EtherCAT System Documentation. A few keywords:

  • CoE in the Master for communication with/through the Slaves
  • Functions from TcEtherCAT.lib
  • Perform an OnlineScan
B In the example chosen (EL3102) the EL3102 comprises two analogue input channels that transmit a single function status for the most recent cycle. Status
  • the bit significations may be found in the device documentation
  • other devices may supply more information, or none that is typical of a slave
 In order for the higher-level PLC task (or corresponding control applications) to be able to rely on correct data, the function status must be evaluated there. Such information is therefore provided with the process data for the most recent cycle.
C For every EtherCAT Slave that has cyclic process data, the Master displays, using what is known as a WorkingCounter, whether the slave is participating successfully and without error in the cyclic exchange of process data. This important, elementary information is therefore provided for the most recent cycle in the System Manager
  1. at the EtherCAT Slave, and, with identical contents
  2. as a collective variable at the EtherCAT Master (see Point A)

for linking.

 WcState (Working Counter)

0: valid real-time communication in the last cycle

1: invalid real-time communication

This may possibly have effects on the process data of other Slaves that are located in the same SyncUnit

 In order for the higher-level PLC task (or corresponding control applications) to be able to rely on correct data, the communication status of the EtherCAT Slave must be evaluated there. Such information is therefore provided with the process data for the most recent cycle.
D Diagnostic information of the EtherCAT Master which, while it is represented at the slave for linking, is actually determined by the Master for the Slave concerned and represented there. This information cannot be characterized as real-time, because it
  • is only rarely/never changed, except when the system starts up
  • is itself determined acyclically (e.g. EtherCAT Status)
 State

current Status (INIT..OP) of the Slave. The Slave must be in OP (=8) when operating normally.

AdsAddr

The ADS address is useful for communicating from the PLC/task via ADS with the EtherCAT Slave, e.g. for reading/writing to the CoE. The AMS-NetID of a slave corresponds to the AMS-NetID of the EtherCAT Master; communication with the individual Slave is possible via the port (= EtherCAT address).

 Information variables for the EtherCAT Master that are updated acyclically. This means that it is possible that in any particular cycle they do not represent the latest possible status. It is therefore possible to read such variables through ADS.

Attention 		Diagnostic information
It is strongly recommended that the diagnostic information made available is evaluated so that the application can react accordingly.

CoE Parameter Directory

The CoE parameter directory (CanOpen-over-EtherCAT) is used to manage the set values for the slave concerned. Changes may, in some circumstances, have to be made here when commissioning a relatively complex EtherCAT Slave. It can be accessed through the TwinCAT System Manager, see Fig. 3:

Fig. 3: EL3102, CoE directory

Note 		EtherCAT System Documentation
The comprehensive descriptionhttp://www.beckhoff.de/german/download/ethercat.htm#SystemDescription"> EtherCAT System Documentation (EtherCAT Basics --> CoE Interface) must be observed!

A few brief extracts:

  • Whether changes in the online directory are saved locally in the slave depends on the device. EL terminals (except the EL66xx) are able to save in this way.
  • The user must manage the changes to the StartUp list.

Commissioning aid in the TwinCAT System Manager

Commissioning interfaces are being introduced as part of an ongoing process for EL/EP EtherCAT devices. These are available in TwinCAT System Managers from TwinCAT 2.11R2 and above. They are integrated into the System Manager through appropriately extended ESI configuration files.

Fig. 4: Example of commissioning aid for a EL3204

This commissioning process simultaneously manages

  • CoE Parameter Directory
  • DC/FreeRun mode
  • the available process data records (PDO)

Although the "Process Data", "DC", "Startup" and "CoE-Online" that used to be necessary for this are still displayed, it is recommended that, if the commissioning aid is used, the automatically generated settings are not changed by it.

The commissioning tool does not cover every possible application of an EL/EP device. If the available setting options are not adequate, the user can make the DC, PDO and CoE settings manually, as in the past.

EtherCAT State: automatic default behaviour of the TwinCAT System Manager and manual operation

After the operating power is switched on, an EtherCAT Slave must go through the following statuses

  • INIT
  • PREOP
  • SAFEOP
  • OP

to ensure sound operation. The EtherCAT Master directs these statuses in accordance with the initialization routines that are defined for commissioning the device by the ES/XML and user settings (Distributed Clocks (DC), PDO, CoE). See also the section on "Principles of Communication, EtherCAT State Machine" in this connection. Depending how much configuration has to be done, and on the overall communication, booting can take up to a few seconds.

The EtherCAT Master itself must go through these routines when starting, until it has reached at least the OP target state.

The target state wanted by the user, and which is brought about automatically at start-up by TwinCAT, can be set in the System Manager. As soon as TwinCAT reaches the status RUN, the TwinCAT EtherCAT Master will approach the target states.

Standard setting

The advanced settings of the EtherCAT Master are set as standard:

  • EtherCAT Master: OP
  • Slaves: OP
    This setting applies equally to all Slaves.

Fig. 5: Default behaviour of the System Manager

In addition, the target state of any particular Slave can be set in the "Advanced Settings" dialogue; the standard setting is again OP.

Fig. 6: Default target state in the Slave

Manual Control

There are particular reasons why it may be appropriate to control the states from the application/task/PLC. For instance:

  • for diagnostic reasons
  • to induce a controlled restart of axes
  • because a change in the times involved in starting is desirable

In that case it is appropriate in the PLC application to use the PLC function blocks from the TcEtherCAT.lib, which is available as standard, and to work through the states in a controlled manner using, for instance, FB_EcSetMasterState.

It is then useful to put the settings in the EtherCAT Master to INIT for master and slave.

Fig. 7: PLC function blocks

Note regarding E-Bus current

EL/ES terminals are placed on the DIN rail at a coupler on the terminal strand. A Bus Coupler can supply the EL terminals added to it with the E-bus system voltage of 5 V; a coupler is thereby loadable up to 2 A as a rule. Information on how much current each EL terminal requires from the E-bus supply is available online and in the catalogue. If the added terminals require more current than the coupler can supply, then power feed terminals (e.g. EL9410) must be inserted at appropriate places in the terminal strand.

The pre-calculated theoretical maximum E-Bus current is displayed in the TwinCAT System Manager as a column value. A shortfall is marked by a negative total amount and an exclamation mark; a power feed terminal is to be placed before such a position.

Fig. 8: illegally exceeding the E-Bus current

From TwinCAT 2.11 and above, a warning message "E-Bus Power of Terminal..." is output in the logger window when such a configuration is activated:

Fig. 9: Warning message for exceeding E-Bus current

Attention 		Caution! Malfunction possible!
The same ground potential must be used for the E-Bus supply of all EtherCAT terminals in a terminal block!


CU1128 - Configuration in the TwinCAT System Manager

BECKHOFF CU1128: Commissioning

Configuration in the TwinCAT System Manager

Like any other EtherCAT slave, the CU1128 can be configured in two different ways in the TwinCAT System Manager:

  • if it already exists and is available online and connected to the configuration PC: through scanning
  • if it does not exist: through manual configuration setup

See section Configuration.

Since the CU1128 with its 3 integrated slaves is a little different from other slaves, some further information is provided below.

Configuration setup through online scan

From TwinCAT 2.10 b1340 (and therefore also TwinCAT 2.11 and higher) the CU1128 is detected during the scan, and the main device plus the two slaves (CU1128-0001 and CU1128-0002) are created.

Fig. 1: scanning EtherCAT devices in Config mode

For verification, ensure that the CU1128 is shown with 3 junctions in one layer in the topology view (see Fig. 2).

Fig. 2: CU1128 topology display in the System Manager

For comparison, Fig. 3 shows an incorrect display, caused by inadmissible relocation of the slaves in the configuration, for example.

Fig. 3: CU1128 topology display

Manual configuration setup

For manual configuration setup of the CU1128 and attached devices, the correct ESI/XML file must be present, see here.

The process in detail:

Fig. 4: right-click and select Append Box

A new device is added in the Ethernet layer. The port specification in the selection dialog (see Fig. 5) plays an essential role: it indicates at which outgoing port of the selected device the new device is to be connected. The selection options depend on the hardware (Ethernet or E-bus) available at ports A, B, C, D. In this example only Ethernet, port B is available at the EtherCAT master.

Fig. 5: selection of the main device CU1128-0000

The revision number can be shown in the selection dialog by ticking ExtendedInformation.

Notice 		Inserting CU1128
To add a CU1128 to a configuration, always use DeviceEtherCAT -> AppendBox and then move it to the required position in the configuration via drag & drop.

Fig. 6: added CU1128 with secondary devices Dev A and Dev B

The PreviousPort field of the secondary devices indicates that they are connected to port C of the previous device.

Fig. 6: previous port specification for CU1128, ESC2

Topology view shows the 3 devices as a chain:

Fig. 7: CU1128 in Topology view

Adding further CU1128 devices

It is common for further devices to be connected to the outgoing ports of the CU1128 at this stage. This is explained below, using a further CU1128 as an example. Make sure that the correct connection point is selected.

Fig. 8: adding further CU1128 devices

Add the CU1128-0000 via DeviceEtherCAT.

Fig. 9: selecting the CU1128-0000

The new Term4 is added after the existing CU1128.

Fig. 10: added CU1128

Then use drag & drop to move it to the required position. In this example the intention is to connect it to port 4 of the CU1128, i.e. port D of ESC2 = Term2. This can be specified via PreviousPort.

Fig. 11: selecting PreviousPort after moving the CU1128

Select Topology view to verify the configuration.

Fig. 12: topology display for 2x CU1128

Further EtherCAT devices

Other EtherCAT devices with Ethernet hardware can also be connected to any ports via AppendBox.

Fig. 13: adding further devices

Only Ethernet devices can be connected to a CU1128. Therefore, please make sure that Ethernet is selected under Port (see Fig. 14, right).

Fig. 14: adding a device

Sequence:

  • A: once the CU1128 has been selected
  • B: and one of the Ethernet ports has been selected
  • C: the new device can be selected.

The E-bus port (see Fig. 15) is not available for selection, since the next CU1128 secondary unit is already connected to it.

Fig. 15: port selection for CU1128


Installation of the TwinCAT real-time driver

In order to assign real-time capability to a standard Ethernet port of an IPC controller, the Beckhoff real-time driver has to be installed on this port under Windows.

This can be done in several ways. One option is described here.

In the System Manager call up the TwinCAT overview of the local network interfaces via Options -> Show Real Time Ethernet Compatible Devices.

Fig. 1: System Manager option

Fig. 2: overview of network interfaces

Interfaces listed under “Compatible devices” can be assigned a driver via the “Install” button. A driver should only be installed on compatible devices.

A Windows warning regarding the unsigned driver can be ignored.

After the installation the driver appears activated in the Windows overview for the network interface (Windows Start -->System Properties -> Network)

Fig. 3: Windows properties of the network interface

Notice 		IP address/DHCP
In most cases an Ethernet port that is configured as an EtherCAT device will not transport general IP packets. For this reason and in cases where an EL6601 or similar devices are used it is useful to specify a fixed IP address for this port via the “Internet Protocol TCP/IP” driver setting and to disable DHCP.

In this way the delay associated with the DHCP client for the Ethernet port assigning itself a default IP address in the absence of a DHCP server is avoided.

A suitable address space is 192.168.x.x, for example.

Fig. 4: TCP/IP setting for the Ethernet port

Alternatively, the compatible Ethernet ports can be viewed in the System Manager via EtherCAT properties.

Fig. 5: EtherCAT device properties


Notes regarding ESI device description

Contents
• Installation of the latest ESI device description
• Device differentiation
• Online Description
• Faulty ESI file

Installation of the latest ESI device description

The TwinCAT EtherCAT master/System Manager needs the device description files for the devices to be used in order to generate the configuration in online or offline mode. The device descriptions are contained in the so-called ESI files (EtherCAT Slave Information) in XML format. These files can be requested from the respective manufacturer and are made available for download. An *.xml file may contain several device descriptions.

The ESI files for Beckhoff EtherCAT devices are available on the Beckhoff website.

The ESI files should be stored in the TwinCAT installation directory (default: C:\TwinCAT\IO\EtherCAT). The files are read (once) when a new System Manager window is opened, if they have changed since the last time the System Manager window was opened.

A TwinCAT installation includes the set of Beckhoff ESI files that was current at the time when the TwinCAT build was created.

For TwinCAT 2.11 and higher, the ESI directory can be updated from the System Manager, if the programming PC is connected to the Internet (Option -> “Update EtherCAT Device Descriptions”)

Fig. 1: for TwinCAT 2.11 and higher, the System Manager can search for current Beckhoff ESI files automatically, if an online connection is available

Notice 		ESI
The *.xml files are associated with *.xsd files, which describe the structure of the ESI XML files. To update the ESI device descriptions, both file types should therefore be updated.

Device differentiation

EtherCAT devices/slaves are distinguished by 4 properties, which determine the full device identifier. The EL2521-0025-1018 ID consists of

  • family key “EL”
  • name “2521”
  • type “0025”
  • and revision “1018”

Fig. 2: identifier structure

The order identifier consisting of name + type (here: EL2521-0010) describes the device function. The revision indicates the technical progress and is managed by Beckhoff. In principle, a device with a higher revision can replace a device with a lower revision, unless specified otherwise. Each revision has its own ESI description. See further notes.

Online description

If the EtherCAT configuration is created online through scanning of real devices (see section Online setup) and no ESI descriptions are available for a slave that was found, the System Manager asks whether the description stored in the device should be used. In any case, the System Manager needs this information for setting up the cyclic and acyclic communication with the slave correctly.

Fig. 3: OnlineDescription information window

If possible, this should be declined, and the required ESI should be requested from the device manufacturer. After installation of the XML/XSD file the configuration process should be repeated.

If the OnlineDescription is used regardless, the System Manager reads a copy of the device description from the EEPROM in the EtherCAT slave. In complex slaves the size of the EEPROM may not be sufficient for the complete ESI, in which case the ESI would be incomplete in the configurator. The route via the ESI files is therefore recommended.

The System Manager creates a new file “OnlineDescription0000...xml” its ESI directory, which contains all ESI descriptions that were read online.

Fig. 4: file OnlineDescription.xml created by the System Manager

If slaves are added manually to the configuration at a later stage, slaves created in the manner described above are indicated by an arrow, see Fig. 5, EL2521.

Fig. 5: Arrow indicates ESI recorded from OnlineDescription

If such ESI files are used and the manufacturer's files become available later, the file OnlineDescription.xml should be deleted as follows:

  • close all System Manager windows
  • restart TwinCAT in Config mode
  • delete OnlineDescription file

Faulty ESI file

If an ESI file is faulty and the System Manager is unable to read it, the System Manager brings up an information window.

Fig. 6: information window for faulty ESI file

Reasons may include:

  • structure of the *.xml file does not match the corresponding *.xsd file
  • content cannot be compiled into a device description

Contact the file supplier.


Offline configuration settings (master: TwinCAT 2.x)

Contents
• Distinction between Online and Offline
• Creating the EtherCAT device
• Defining EtherCAT slaves

Distinction between Online and Offline

The distinction between online and offline refers to the presence of the actual I/O environment (drives, terminals). If the configuration is to be prepared in advance of the system configuration as a programming system, e.g. on a laptop, this is only possible in “Offline configuration” mode. In this case all components have to be entered manually in the configuration, e.g. based on the electrical design.

If the designed control system is already connected to the EtherCAT system and all components are energized and the infrastructure is ready for operation, the TwinCAT configuration can simply be generated through “scanning” from the runtime system. This is referred to as online configuration.

In any case, during each startup the EtherCAT master checks whether the slaves it finds match the configuration. This test can be parameterized in the extended slave settings.

Notice 		Installation of the latest ESI-XML device description
The TwinCAT EtherCAT master/System Manager needs the device description files for the devices to be used in order to generate the configuration in online or offline mode. The device descriptions are contained in the so-called ESI files (EtherCAT Slave Information) in XML format. These files can be requested from the respective manufacturer and are made available for download. The ESI files for Beckhoff EtherCAT devices are available on the Beckhoff website.

The ESI files should be saved in the TwinCAT installation directory (default: C:\TwinCAT\IO\EtherCAT ). The files are read (once) when a new System Manager window is opened.

A TwinCAT installation includes the set of Beckhoff ESI files that was current at the time when the TwinCAT build was created.

For TwinCAT 2.11 and higher, the ESI directory can be updated from the System Manager, if the programming PC is connected to the Internet (Option -> “Update EtherCAT Device Descriptions”)

The following conditions must be met before a configuration can be set up:

  • the EtherCAT device must be defined in the System Manager
  • the EtherCAT slaves must be defined

Creating the EtherCAT device

Create an EtherCAT device in an empty System Manager window.

Fig. 1: Append EtherCAT device

Select type ‘EtherCAT’ for an EtherCAT I/O application with EtherCAT slaves. For the present publisher/subscriber service in combination with an EL6601/EL6614 terminal select “EtherCAT Automation Protocol via EL6601”.

Fig. 2: selecting the EtherCAT connection (TwinCAT 2.11)

Fig. 3: selecting the EtherCAT connection (TwinCAT 2.11 R2)

Then assign a real Ethernet port to this virtual device in the runtime system.

Fig. 4: selecting the Ethernet port

This query may appear automatically when the EtherCAT device is created, or the assignment can be set/modified later in the properties dialog (see Fig. 5).

Fig. 5: EtherCAT properties dialog

Notice 		selecting the Ethernet port
Ethernet ports can only be selected for EtherCAT devices for which the TwinCAT real-time driver is installed. This has to be done separately for each port.

Please refer to the respective installation page.

Defining EtherCAT slaves

Further devices can be appended by right-clicking on a device in the configuration tree.

Fig. 6: Appending EtherCAT devices

The dialog for selecting a new device opens. Only devices for which ESI files are available are displayed.

Only devices are offered for selection that can be appended to the previously selected device. Therefore the physical layer available for this port is also displayed (Fig. 7, A). In the case of cable-based Fast-Ethernet physical layer with PHY transfer, then also only cable-based devices are available, as shown in Fig. 7. If the preceding device has several free ports (e.g. EK1122 or EK1100), the required port can be selected on the right-hand side (A).

Overview of physical layer

  • “Ethernet”: cable-based 100BASE-TX: EK couplers, EP boxes, devices with RJ45/M8/M12 connector
  • “E-Bus”: LVDS “terminal bus”: EL/ES terminals, various modular modules

The search field facilitates finding specific devices (TwinCAT 2.11 or higher).

Fig. 7: selection dialog for new EtherCAT device

By default only the name/device type is used as selection criterion. For selecting a specific revision of the device the revision can be displayed as “Extended Information”.

Fig. 8: display of device revision

In many cases several device revisions were created for historic or functional reasons, e.g. through technological advancement. For simplification purposes (see Fig. 7) only the last (i.e. highest) revision and therefore the latest state of production is displayed in the selection dialog for Beckhoff devices. To show all device revisions available in the system as ESI descriptions tick the “Show Hidden Devices” check box, see Fig. 9.

Fig. 9: display of previous revisions

Notice 		Device selection based on revision, compatibility
The ESI description also defines the process image, the communication type between master and slave/device and the device functions, if applicable. The physical device (firmware, if available) has to support the communication queries/settings of the master. This is backward compatible, i.e. newer devices (higher revision) should be supported if the EtherCAT master addresses them as an older revision. The following compatibility rule of thumb is to be assumed for Beckhoff EtherCAT Terminals/Boxes:

device revision in the system >= device revision in the configuration

This also enables subsequent replacement of devices without changing the configuration (different specifications are possible for drives).

Example: If an EL2521-0025-1018 is specified in the configuration, an EL2521-0025-1019 or higher (-1020, -1021) can be used in practice.

If current ESI descriptions are available in the TwinCAT system, the last revision offered in the selection dialog matches the Beckhoff state of production. It is recommended to use the last device revision when creating a new configuration, if current Beckhoff devices are used in the real application. Older revisions should only be used if older devices from stock are to be used in the application.

In this case the process image of the device is shown in the configuration tree and can be parameterized as follows: linking with the task, CoE/DC settings, plug-in definition, startup settings, ...

Fig. 10: EtherCAT terminal in the TwinCAT tree


Online configuration settings “Scanning” (master: TwinCAT 2.x)

Contents
• Distinction between Online and Offline
• Detecting/scanning of the EtherCAT device
• Detecting/Scanning the EtherCAT devices
• Trouble shooting
• Scan over existing Configuration

Distinction between Online and Offline

The distinction between online and offline refers to the presence of the actual I/O environment (drives, terminals). If the configuration is to be prepared in advance of the system configuration as a programming system, e.g. on a laptop, this is only possible in “Offline configuration” mode. In this case all components have to be entered manually in the configuration, e.g. based on the electrical design.

If the designed control system is already connected to the EtherCAT system and all components are energized and the infrastructure is ready for operation, the TwinCAT configuration can simply be generated through “scanning” from the runtime system. This is referred to as online configuration.

In any case, during each startup the EtherCAT master checks whether the slaves it finds match the configuration. This test can be parameterized in the extended slave settings.

Notice 		Installation of the latest ESI-XML device description
The TwinCAT EtherCAT master/System Manager needs the device description files for the devices to be used in order to generate the configuration in online or offline mode. The device descriptions are contained in the so-called ESI files (EtherCAT Slave Information) in XML format. These files can be requested from the respective manufacturer and are made available for download. The ESI files for Beckhoff EtherCAT devices are available on the Beckhoff website..

The ESI files should be saved in the TwinCAT installation directory (default: C:\TwinCAT\IO\EtherCAT ). The files are read (once) when a new System Manager window is opened.

A TwinCAT installation includes the set of Beckhoff ESI files that was current at the time when the TwinCAT build was created.

For TwinCAT 2.11 and higher, the ESI directory can be updated from the System Manager, if the programming PC is connected to the Internet (Option -> “Update EtherCAT Device Descriptions”)

The following conditions must be met before a configuration can be set up:

  • the real EtherCAT hardware (devices, couplers, drives) must be present and installed
  • the devices/modules must be connected via EtherCAT cables or in the terminal strand in the same way as they are intended to be used later
  • the devices/modules be connected to the power supply and ready for communication
  • TwinCAT must be in CONFIG mode on the target system.

The online scan process consists of:

  • detecting the EtherCAT device (Ethernet port at the IPC)
  • detecting the connected EtherCAT devices. This step can be carried out independent of the preceding step
  • troubleshooting

The scan with existing configuration can also be carried out for comparison.

Detecting/scanning of the EtherCAT device

The online device search can be used if the TwinCAT system is in CONFIG mode (blue TwinCAT icon or blue indication in the System Manager).

Fig. 1: TwinCAT CONFIG mode display

Notice 		Online scanning in Config mode
The online search is not available in RUN mode (production operation).

Note the differentiation between TwinCAT programming system and TwinCAT target system. The TwinCAT icon next to the Windows clock always shows the TwinCAT mode of the local IPC. The System Manager window shows the TwinCAT state of the target system.

Right-clicking on “I/O Devices” in the configuration tree opens the search dialog.

Fig. 2: Scan Devices

This scan mode not only tries to find EtherCAT devices (or Ethernet ports that can be used as such), but also NOVRAM, fieldbus cards, SMB etc. Not all devices can be found automatically.

Fig. 3: note for automatic device scan

Ethernet ports with installed TwinCAT real-time driver are shown as “RT Ethernet” devices. An EtherCAT frame is sent to these ports for testing purposes. If the scan agent detects from the response that an EtherCAT slave is connected, the port is immediately shown as an “EtherCAT Device” .

Fig. 4: detected Ethernet devices

After confirmation with “OK” a device scan is suggested for all selected devices, see Fig. 5.

Detecting/Scanning the EtherCAT devices

Notice 		Online scan functionality
During a scan the master queries the identity information of the EtherCAT slaves from the slave EEPROM. The name and revision are used for determining the type. The respective devices are located in the stored ESI data and integrated in the configuration tree in the default state defined there.

If an EtherCAT device was created in the configuration (manually or through a scan), the I/O field can be scanned for devices/slaves.

Fig. 5: scan query after automatic creation of an EtherCAT device

Fig. 6: Manual triggering of a device scan on a specified EtherCAT device

In the System Manager the scan process can be monitored via the progress bar at the bottom of the screen.

Fig. 7: scan progress

The configuration is established and can then be switched to online state (OPERATIONAL).

Fig. 8: Config/FreeRun query

In Config/FreeRun mode the System Manager display alternates between blue and red, and the EtherCAT device continues to operate with the idling cycle time of 4 ms (default setting), even without active task (NC, PLC).

Fig. 9: Config/FreeRun indicator

Notice 		Note for Config/FreeRun
TwinCAT can also be switched to this state by using a button

The EtherCAT system should then be in a functional cyclic state, as shown in Fig. 10.

Fig. 10: online display example

Please note:

  • all slaves should be in OP state
  • the EtherCAT master should be in “Actual State” OP
  • “frames/sec” should match the cycle time taking into account the sent number of frames
  • no excessive “LostFrames” or CRC errors should occur

The configuration is now complete. It can be modified as described under manual procedure.

Troubleshooting

Various effects may occur during scanning.

  • An unknown device is detected, i.e. an EtherCAT slave for which no ESI XML description is available.
    In this case the System Manager offers to read any ESI that may be stored in the device. This case is described here.
  • Device are not detected properly
    Possible reasons include:
    - faulty data links, resulting in data loss during the scan
    - slave has invalid device description
    The connections and devices should be checked in a targeted manner, e.g. via the emergency scan.
    Then re-run the scan.

    Fig. 11: faulty identification

    In the System Manager such devices may be set up as EK0000 or unknown devices. Operation is not possible or meaningful.

Scan over existing Configuration

If a scan is initiated for an existing configuration, the actual I/O environment may match the configuration exactly or it may differ. This enables the configuration to be compared.

Fig. 12: identical configuration

If differences are detected, they are shown in the correction dialog, so that the user can modify the configuration as required.

Fig. 13: correction dialog

It is advisable to tick the “Extended Information” check box to reveal differences in the revision.

Colour | Explanation
green | This EtherCAT slave matches the entry on the other side. Both type and revision match.
blue This EtherCAT slave is present on the other side, but in a different revision. It is possible, that this different revision has also different default settings of the process data and different/additional functions.
If the found revision is higher than the configured revision, the slave may be used provided compatibility issues are taken into account.

If the found revision is lower than the configured revision, it is likely that the slave cannot be used. The found device may not support all functions that the master expects based on the higher revision number.
light blue | This EtherCAT slave is ignored (“Ignore” button)
red
  • This EtherCAT slave is not present on the other side.
  • or the slave is present, but in another revision, which differs also from the characteristics of the specified revision.
    The compatibility principle applies here, too: if the the scanned revision is higher than the configured revision, the operation is possible considering the compatibility, because successor devices should support the functions of the predecessor devices.
    If the scanned revision is lower than the configured revision, the operation is presumably not possible. In this case, the scanned device eventually does not support all functions, which are expected to the master due to the higher revision

Notice 		Device selection based on revision, compatibility
The ESI description also defines the process image, the communication type between master and slave/device and the device functions, if applicable. The physical device (firmware, if available) has to support the communication queries/settings of the master. This is backward compatible, i.e. newer devices (higher revision) should be supported if the EtherCAT master addresses them as an older revision. The following compatibility rule of thumb is to be assumed for Beckhoff EtherCAT Terminals/Boxes:

device revision in the system >= device revision in the configuration

This also enables subsequent replacement of devices without changing the configuration (different specifications are possible for drives).

Example: If an EL2521-0025-1018 is specified in the configuration, an EL2521-0025-1019 or higher (-1020, -1021) can be used in practice.

If current ESI descriptions are available in the TwinCAT system, the last revision offered in the selection dialog matches the Beckhoff state of production. It is recommended to use the last device revision when creating a new configuration, if current Beckhoff devices are used in the real application. Older revisions should only be used if older devices from stock are to be used in the application.

Fig. 14: correction dialog with modifications

Once all modifications have been saved or accepted, click “OK” to transfer them to the real *.tsm configuration.


TwinCAT System Manager - Configuration

BECKHOFF TwinCAT System Manager: Configuration

Configuration by means of the TwinCAT System Manager

(with TwinCAT from version 2.10.0 (Build 1241), using EL5001 from firmware version 0.7 as an example)

In the left-hand window of the TwinCAT System Manager, click on the branch you wish to configure (in the example: EL5001 Terminal 6).

In the right-hand window of the TwinCAT System manager, various tabs are now available for configuring the terminal.

General tab

Name | Name of the EtherCAT device
Id | Number of the EtherCAT device
Type | EtherCAT device type
Comment | Here you can add a comment (e.g. regarding the system).
Disabled | Here you can deactivate the EtherCAT device.
Create symbols | Access to this EtherCAT slave via ADS is only available if this control box is activated.

EtherCAT tab

Type | EtherCAT device type
Product/Revision | Product and revision number of the EtherCAT device
Auto Inc Addr. | Auto increment address of the EtherCAT device. The auto increment address can be used for addressing each EtherCAT device in the communication ring through its physical position. Auto increment addressing is used during the start-up phase when the EtherCAT master allocates addresses to the EtherCAT devices. With auto increment addressing the first EtherCAT slave in the ring has the address 0000hex. For each further slave the address is decremented by 1 (FFFFhex, FFFEhex etc.).
EtherCAT Addr. | Fixed address of an EtherCAT slave. This address is allocated by the EtherCAT master during the start-up phase. Tick the control box to the left of the input field in order to modify the default value.
Previous Port | Name and port of the EtherCAT device to which this device is connected. If it is possible to connect this device with another one without changing the order of the EtherCAT devices in the communication ring, then this combination field is activated and the EtherCAT device to which this device is to be connected can be selected.
Advanced Settings | This button opens the dialogs for advanced settings.

The link at the bottom of the tab points to the product page for this EtherCAT device on the web.

Process Data tab

Indicates the configuration of the process data. The input and output data of the EtherCAT slave are represented as CANopen process data objects (PDO). The user can select a PDO via PDO assignment and modify the content of the individual PDO via this dialog, if the EtherCAT slave supports this function.

Sync Manager

Lists the configuration of the Sync Manager (SM).
If the EtherCAT device has a mailbox, SM0 is used for the mailbox output (MbxOut) and SM1 for the mailbox input (MbxIn).
SM2 is used for the output process data (outputs) and SM3 (inputs) for the input process data.

If an input is selected, the corresponding PDO assignment is displayed in the PDO Assignment list below.

PDO Assignment

PDO assignment of the selected Sync Manager. All PDOs defined for this Sync Manager type are listed here:

  • If the output Sync Manager (outputs) is selected in the Sync Manager list, all RxPDOs are displayed.
  • If the input Sync Manager (inputs) is selected in the Sync Manager list, all TxPDOs are displayed.

The selected entries are the PDOs involved in the process data transfer. In the tree diagram of the System Manager these PDOs are displayed as variables of the EtherCAT device. The name of the variable is identical to the Name parameter of the PDO, as displayed in the PDO list. If an entry in the PDO assignment list is deactivated (not selected and greyed out), this indicates that the input is excluded from the PDO assignment. In order to be able do select a greyed out PDO, the currently selected PDO has to be deselected first.

Note 		Activation of PDO assignment
If you have changed the PDO assignment, in order to activate the new PDO assignment,
  • the EtherCAT slave has to run through the PS status transition cycle (from pre-operational to safe-operational) once (see Online tab),
  • and the System Manager has to reload the EtherCAT slaves ( [image] button)

PDO list

List of all PDOs supported by this EtherCAT device. The content of the selected PDOs is displayed in the PDO Content list. The PDO configuration can be modified by double-clicking on an entry.

Column | Description
Index | PDO index.
Size | Size of the PDO in bytes.
Name | Name of the PDO. If this PDO is assigned to a Sync Manager, it appears as a variable of the slave with this parameter as the name.
Flags | F | Fixed content: The content of this PDO is fixed and cannot be changed by the System Manager.
 | M | Mandatory PDO. This PDO is mandatory and must therefore be assigned to a Sync Manager! Consequently, this PDO cannot be deleted from the PDO Assignment list
SM | Sync Manager to which this PDO is assigned. If this entry is empty, this PDO does not take part in the process data traffic.
SU | Sync unit to which this PDO is assigned.

PDO Content

Indicates the content of the PDO. If flag F (fixed content) of the PDO is not set the content can be modified.

Download

If the device is intelligent and has a mailbox, the configuration of the PDO and the PDO assignments can be downloaded to the device. This is an optional feature that is not supported by all EtherCAT slaves.

PDO Assignment

If this check box is selected, the PDO assignment that is configured in the PDO Assignment list is downloaded to the device on startup. The required commands to be sent to the device can be viewed in the Startup tab.

PDO Configuration

If this check box is selected, the configuration of the respective PDOs (as shown in the PDO list and the PDO Content display) is downloaded to the EtherCAT slave.

Startup tab

The Startup tab is displayed if the EtherCAT slave has a mailbox and supports the CANopen over EtherCAT (CoE) or Servo drive over EtherCAT protocol. This tab indicates which download requests are sent to the mailbox during startup. It is also possible to add new mailbox requests to the list display. The download requests are sent to the slave in the same order as they are shown in the list.

Column | Description
Transition Transition to which the request is sent. This can either be
  • the transition from pre-operational to safe-operational (PS), or
  • the transition from safe-operational to operational (SO).

If the transition is enclosed in "<>" (e.g. <PS>), the mailbox request is fixed and cannot be modified or deleted by the user.
Protocol | Type of mailbox protocol
Index | Index of the object
Data | Date on which this object is to be downloaded.
Comment | Description of the request to be sent to the mailbox
Move Up | This button moves the selected request up by one position in the list.
Move Down | This button moves the selected request down by one position in the list.
New | This button adds a new mailbox download request to be sent during startup.
Delete | This button deletes the selected entry.
Edit | This button edits an existing request.

CoE - Online tab

The additional CoE - Online tab is displayed if the EtherCAT slave supports the CANopen over EtherCAT (CoE) protocol. This dialog lists the content of the object list of the slave (SDO upload) and enables the user to modify the content of an object from this list. Details for the objects of the individual EtherCAT devices can be found in the device-specific object descriptions.

Object list display
Column | Description
Index | Index and sub-index of the object
Name | Name of the object
Flags | RW | The object can be read, and data can be written to the object (read/write)
 | RO | The object can be read, but no data can be written to the object (read only)
 | P | An additional P identifies the object as a process data object.
Value | Value of the object
Update List | The Update list button updates all objects in the displayed list
Auto Update | If this check box is selected, the content of the objects is updated automatically.
Advanced | The Advanced button opens the Advanced Settings dialog. Here you can specify which objects are displayed in the list.

Online - via SDO Information | If this option button is selected, the list of the objects included in the object list of the slave is uploaded from the slave via SDO information. The list below can be used to specify which object types are to be uploaded.
Offline - via EDS File | If this option button is selected, the list of the objects included in the object list is read from an EDS file provided by the user.

Online tab

State Machine

Init | This button attempts to set the EtherCAT device to the Init state.
Pre-Op | This button attempts to set the EtherCAT device to the pre-operational state.
Op | This button attempts to set the EtherCAT device to the operational state.
Bootstrap | This button attempts to set the EtherCAT device to the Bootstrap state.
Safe-Op | This button attempts to set the EtherCAT device to the safe-operational state.
Clear Error | This button attempts to delete the fault display. If an EtherCAT slave fails during change of state it sets an error flag. Example: An EtherCAT slave is in PREOP state (pre-operational). The master now requests the SAFEOP state (safe-operational). If the slave fails during change of state it sets the error flag. The current state is now displayed as ERR PREOP. When the Clear Error button is pressed the error flag is cleared, and the current state is displayed as PREOP again.
Current State | Indicates the current state of the EtherCAT device.
Requested State | Indicates the state requested for the EtherCAT device.

DLL Status

Indicates the DLL status (data link layer status) of the individual ports of the EtherCAT slave. The DLL status can have four different states:

Status | Description
No Carrier / Open | No carrier signal is available at the port, but the port is open.
No Carrier / Closed | No carrier signal is available at the port, and the port is closed.
Carrier / Open | A carrier signal is available at the port, and the port is open.
Carrier / Closed | A carrier signal is available at the port, but the port is closed.

File Access over EtherCAT

Download | With this button a file can be written to the EtherCAT device.
Upload | With this button a file can be read from the EtherCAT device.


CU1128 - LED Displays

BECKHOFF CU1128: Commissioning

LED Displays

Ethernet

For each channel 1 LED shows the current status.

LED display per channel
LED | Display
Link Act | off | no connection
 | on | connection established (Link)
 | flashing | data transmission active (Act)

Power Supply

Present supply voltage (24 VDC) is shown by the green power LED.


CU1128 - EEPROM update

BECKHOFF CU1128: Appendix

EEPROM Update

The CU1128 features 3 internal EtherCAT slave controllers (ESCs). This means that 3 EEPROMs are available for write access. In the CU1128 they are different, since all 3 ESCs have different port technology (Ethernet or E-bus), see Fig. 1.

Fig. 1: the 3 internal ESC names of the CU1128

The main slave is the CU1128-0000, in this case revision -0000. The two following internal slaves are CU1128-0001 and CU1128-0002.

The EEPROM can be updated via the EEPROM Update dialog in the System Manager. This is only necessary in special cases and should only be done if instructed by Beckhoff support/service.

Fig. 2: EEPROM Update TwinCAT

All 3 internal ESCs can be write-accessed sequentially, followed by an off/on restart, in order to load the EEPROM. See Fig. 3 for assignment in the TwinCAT selection dialog.

Fig. 3: currently available EEPROM descriptions for CU1128 and assignment

Dev A is intended for ESC2 CU1128-0001, Dev B for ESC3, CU1128-0002.


UL Requirements

BECKHOFF EKxxxx, ELxxxx: Appendix

UL notice

Application
Beckhoff EtherCAT modules are intended for use with Beckhoff’s UL Listed EtherCAT System only.
Examination
For cULus examination, the Beckhoff I/O System has only been investigated for risk of fire and electrical shock (in accordance with UL508 and CSA C22.2 No. 142).
For devices with Ethernet connectors
Not for connection to telecommunication circuits.

Basic principles

Two UL certificates are met in the Beckhoff EtherCAT product range, depending upon the components:

  • UL certification according to UL508
    Devices with this kind of certification are marked by this sign:

  • UL certification according to UL508 with limited power consumption
    The current consumed by the device is limited to a max. possible current consumption of 4 A. Devices with this kind of certification are marked by this sign:

Almost all current EtherCAT products (as at 2010/05) are UL certified without restrictions.

Application

If terminals certified with restrictions are used, then the current consumption at 24 V DC must be limited accordingly by means of supply

  • from an isolated source protected by a fuse of max. 4A (according to UL248) or
  • from a voltage supply complying with NEC class 2.
    A voltage source complying with NEC class 2 may not be connected in series or parallel with another NEC class 2 compliant voltage supply!

These requirements apply to the supply of all EtherCAT bus couplers, power adaptor terminals, Bus Terminals and their power contacts.


Support and Service

Beckhoff and their partners around the world offer comprehensive support and service, making available fast and competent assistance with all questions related to Beckhoff products and system solutions.

Beckhoff's branch offices and representatives

Please contact your Beckhoff branch office or representative for local support and service on Beckhoff products!

The addresses of Beckhoff's branch offices and representatives round the world can be found on her internet pages:
http://www.beckhoff.com

You will also find further documentation for Beckhoff components there.

Beckhoff Headquarters

Beckhoff Automation GmbH

Eiserstr. 5
33415 Verl
Germany

Phone: | +49(0)5246/963-0
Fax: | +49(0)5246/963-198
e-mail: | info@beckhoff.com
Beckhoff Support

Support offers you comprehensive technical assistance, helping you not only with the application of individual Beckhoff products, but also with other, wide-ranging services:

  • support
  • design, programming and commissioning of complex automation systems
  • and extensive training program for Beckhoff system components
Hotline: | +49(0)5246/963-157
Fax: | +49(0)5246/963-9157
e-mail: | support@beckhoff.com
Beckhoff Service

The Beckhoff Service Center supports you in all matters of after-sales service:

  • on-site service
  • repair service
  • spare parts service
  • hotline service
Hotline: | +49(0)5246/963-460
Fax: | +49(0)5246/963-479
e-mail: | service@beckhoff.com


EtherCAT slave process data settings (PDO)

The process data transferred by an EtherCAT slave during each cycle (Process Data Objects, PDOs) are user data which the application expects to be updated cyclically or which are sent to the slave. To this end the EtherCAT master (Beckhoff TwinCAT) parameterizes each EtherCAT slave during the start-up phase to define which process data (size in bits/bytes, source location, transmission type) it wants to transfer to or from this slave. Incorrect configuration can prevent successful start-up of the slave.

For Beckhoff EtherCAT EL/ES slaves the following applies in general:

  • The input/output process data supported by the device are defined by the manufacturer in the ESI/XML description. The TwinCAT EtherCAT Master uses the ESI description to configure the slave correctly.
  • The process data can be modified in the system manager. See the device documentation.
    Examples of modifications include: mask out a channel, displaying additional cyclic information, 16-bit display instead of 8-bit data size, etc.
  • In so-called “intelligent” EtherCAT devices the process data information is also stored in the CoE directory. Any changes in the CoE directory that lead to different PDO settings prevent successful startup of the slave. It is not advisable to deviate from the designated process data, because the device firmware (if available) is adapted to these PDO combinations.

If the device documentation allows modification of process data, proceed as follows (see Figure 1).

  • A: select the device to configure
  • B: in the “Process Data” tab select Input or Output under SyncManager (C)
  • D: the PDOs can be selected or deselected
  • H: the new process data are visible as linkable variables in the system manager
    The new process data are active once the configuration has been activated and TwinCAT has been restarted (or the EtherCAT master has been restarted)
  • E: if a slave supports this, Input and Output PDO can be modified simultaneously by selecting a so-called PDO record (“predefined PDO settings”).

Fig. 1: Configuring the process data

Note 		Manual modification of the process data
According to the ESI description, a PDO can be identified as “fixed” with the flag “F” in the PDO overview (Fig. 1, J). The configuration of such PDOs cannot be changed, even if TwinCAT offers the associated dialog (“Edit”).

In particular, CoE content cannot be displayed as cyclic process data.

This generally also applies in cases where a device supports download of the PDO configuration, “G”.

In case of incorrect configuration the EtherCAT slave usually refuses to start and change to OP state. The System Manager displays an “invalid SM cfg” logger message:

This error message (“invalid SM IN cfg” or “invalid SM OUT cfg”) also indicates the reason for the failed start.